#include <iostream>
#include <vector>
#include <set>

using namespace std;

constexpr int N = 100002;
int h[N];
int tree[4 * N];

int get(const int x, const int lx, const int rx, const int l, const int r) {
    if (l <= lx && rx <= r) {
        return tree[x];
    }
    if (rx <= l || lx >= r) {
        return 0;
    }
    const int mid = (lx + rx) / 2;
    return max(get(2 * x + 1, lx, mid, l, r), get(2 * x + 2, mid, rx, l, r));
}

void build(const int x, const int lx, const int rx) {
    if (rx - lx == 1) {
        tree[x] = h[lx];
        return;
    }
    int mid = (lx + rx) / 2;
    build(2 * x + 1, lx, mid);
    build(2 * x + 2, mid, rx);
    tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> h[i];
    build(0, 0, n);
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.insert({i, i + 1});
    }
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        k--;
        int u = 0;
        int l1 = -1, r2 = -1;
        pair<int, int> v1, v2;
        for (auto el: s) {
            if (u == k) {
                v1 = el;
                l1 = el.first;
            }
            if (u == k + 1) {
                v2 = el;
                r2 = el.second;
                break;
            }
            u += 1;
        }
        s.erase(v1);
        s.erase(v2);
        s.insert({l1, r2});
        int w = 0;
        for (int j = l1; j < r2; j++) {
            int lj = get(0, 0, n, l1, j + 1);
            int rj = get(0, 0, n, j, r2);
            w += min(lj, rj) - h[j];
        }
        cout << w << '\n';
    }
    return 0;
}
