#include <iostream>
#include <vector>
#include <set>

using namespace std;

constexpr long long N = 100002;
long long h[N];
long long tree[4 * N];

long long get(const long long x, const long long lx, const long long rx, const long long l, const long long r) {
    if (l <= lx && rx <= r) {
        return tree[x];
    }
    if (rx <= l || lx >= r) {
        return 0;
    }
    const long long mid = (lx + rx) / 2;
    return max(get(2 * x + 1, lx, mid, l, r), get(2 * x + 2, mid, rx, l, r));
}

void build(const long long x, const long long lx, const long long rx) {
    if (rx - lx == 1) {
        tree[x] = h[lx];
        return;
    }
    long long mid = (lx + rx) / 2;
    build(2 * x + 1, lx, mid);
    build(2 * x + 2, mid, rx);
    tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long long n;
    cin >> n;
    for (long long i = 0; i < n; i++) cin >> h[i];
    build(0, 0, n);
    set<pair<long long, long long> > s;
    for (long long i = 0; i < n; i++) {
        s.insert({i, i + 1});
    }
    for (long long i = 0; i < n - 1; i++) {
        long long k;
        cin >> k;
        k--;
        long long u = 0;
        long long l1 = -1, r2 = -1;
        pair<long long, long long> v1, v2;
        for (auto el: s) {
            if (u == k) {
                v1 = el;
                l1 = el.first;
            }
            if (u == k + 1) {
                v2 = el;
                r2 = el.second;
                break;
            }
            u += 1;
        }
        s.erase(v1);
        s.erase(v2);
        s.insert({l1, r2});
        long long w = 0;
        for (long long j = l1; j < r2; j++) {
            long long lj = get(0, 0, n, l1, j + 1);
            long long rj = get(0, 0, n, j, r2);
            w += min(lj, rj) - h[j];
        }
        cout << w << '\n';
    }
    return 0;
}
